/*
  copyright(c) 2003-2006 Miki Akiyoshi
  
  This file is part of Miki ThinkingMap.
  
  Miki ThinkingMap is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki ThinkingMap is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki ThinkingMap; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.thinkingmap ;


import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.beans.* ;
import java.io.* ;
import java.util.prefs.Preferences ;
import java.awt.datatransfer.* ;
import jp.dip.ikim.core.* ;
import static jp.dip.ikim.core.mkConfig.DIR_NAME ;
import static jp.dip.ikim.core.mkConfig.DEF_DIR_NAME ;

public class mkApplet extends mkSimpleApplet 
{
    public static final String FILE_NAME = "file_name" ;
    public static final String DEF_FILE_NAME = "mymap.ser" ;

    public static final String LAST_FILE_NAME = "last_file_name" ;

    public static final String SVG_NAME = "SVGt@C" ;
    public static final String DEF_SVG_NAME = "thinkingmap.svg" ;

    public static final String HTML_NAME = "html_name" ;
    public static final String DEF_HTML_NAME = "thinkingmap.html" ;

    public static final String TEXT_NAME = "text_name" ;
    public static final String DEF_TEXT_NAME = "thinkingmap.txt" ;

    public static final String REC_TIME = "R[hԊuibj" ;
    public static final String DEF_REC_TIME = "60" ;

    public static final String MEMO_JAR = "Memo(JARt@C)" ;
    public static final String DEF_MEMO_JAR = "mikimemo10.jar" ;

    public static final String CMATRIX_JAR = "Matrix(JARt@C)" ;
    public static final String
	DEF_CMATRIX_JAR = "mikicreativematrix10.jar" ;

    public static final String PLAYBACK_JAR = "vCobN(JARt@C)" ;
    public static final String DEF_PLAYBACK_JAR = 
	"mikiimageflip10.jar" ;


    public static final int NODE = 1 ;

    public static final int RELATION = 3 ;

    public static final int SUBJECT = 2 ;

    private JPanel _panel ;

    public mkApplet()
    {
	super() ;
    }

    static final String tl =
	"Miki ThinkingMap Ver 2.0 copyright(c) 2003-2006 Miki Akiyoshi" ;

    public static void main(String[] args) 
    {
	JFrame frame = new JFrame(tl);

        mkApplet applet = new mkApplet() ;
	
	applet.setInitMode(args) ;

	applet.setSize(920, 700) ;
	
	frame.setLocationByPlatform(true) ;
	frame.getContentPane().add("Center", applet) ;
	frame.pack();
	frame.setSize(920, 700) ;

	applet.start() ;
	applet.init() ;
	
	frame.setVisible(true) ;
    }


    private mkLeftWidget left ;

    public mkLeftWidget getLeftWidget()
    {
	return left ;
    }

    public mkOutlineDialog getOutlineDialog()
    {
	return left.getOutlineDialog() ;
    }

    public void init()
    {
	super.init() ;

	_cfg.add_line(SVG_NAME, DEF_SVG_NAME, null, mkConfig.TYPE.PLAIN) ;
	
	_cfg.add_line(HTML_NAME,DEF_HTML_NAME,null, mkConfig.TYPE.PLAIN) ;
		
	_cfg.add_line(TEXT_NAME,DEF_TEXT_NAME, null, mkConfig.TYPE.PLAIN) ;

	_cfg.add_line(REC_TIME,DEF_REC_TIME, null, mkConfig.TYPE.PLAIN) ;

	_cfg.add_line(MEMO_JAR,DEF_MEMO_JAR, null, mkConfig.TYPE.PLAIN) ;

	_cfg.add_line(CMATRIX_JAR,DEF_CMATRIX_JAR, 
		      null, mkConfig.TYPE.PLAIN) ;
	_cfg.add_line(PLAYBACK_JAR,DEF_PLAYBACK_JAR, null,mkConfig.TYPE.PLAIN);

	mkLayer lay = new mkMultiLayer() ;
	lay.set_layer(mkApplet.NODE, mkLayer.TYPE.ADD) ;
	lay.set_layer(mkApplet.SUBJECT, mkLayer.TYPE.ADD) ;
	lay.set_layer(mkApplet.RELATION, mkLayer.TYPE.ADD) ;

	mkLayer mlay = createMoveLayer();

	getContentPane().setLayout(null) ;

	JMenuBar bar = new JMenuBar() ;
	JMenu menu  = null ;
	JMenuItem mi  = null ;
	Class	c = getClass() ;
	Toolkit tk  = Toolkit.getDefaultToolkit() ;
	Image img = null ;

	menu = new JMenu("t@C(F)") ;
	menu.setMnemonic(KeyEvent.VK_F);

	mi = new JMenuItem("VK쐬(N)", KeyEvent.VK_N) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_N, ActionEvent.CTRL_MASK));
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    renew() ;
		}}) ;
	menu.add(mi) ;
	

	mi = new JMenuItem("t@CJ(O)", KeyEvent.VK_O) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_O, ActionEvent.CTRL_MASK));
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    load_from() ;
		}}) ;
	menu.add(mi) ;
	
	mi = new JMenuItem("t@Cɕۑ(S)", KeyEvent.VK_S) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_S, ActionEvent.CTRL_MASK));
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    save() ;
		}}) ;
	menu.add(mi) ;
	
	mi = new JMenuItem("Oĕۑ(A)", KeyEvent.VK_A) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    save_as() ;
		}}) ;
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("I(X)", KeyEvent.VK_X) ;
	mi.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
		finish_event() ;
	    }}) ;
	
	menu.add(mi) ;
	bar.add(menu) ;

	menu = new JMenu("ҏW(E)") ;
	menu.setMnemonic(KeyEvent.VK_E);

	mi = new JMenuItem("(F)", KeyEvent.VK_F) ;
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("Vl̒ǉ(K)", KeyEvent.VK_K) ;
	img = tk.createImage(c.getResource("images/icon04.gif")) ;
	mi.addActionListener(new mkFreeHandRubber(this, img,
						  new mkAddNodeAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("eLXgҏW(T)", KeyEvent.VK_T) ;
	mi.addActionListener(new mkPickUp(this, null, 
					  new mkTextEditAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("֌Wt(R)", KeyEvent.VK_R) ;
	mi.addActionListener(new mkAddRelationAction(this)) ;
	menu.add(mi) ;

	mi = new JMenuItem("폜(D)", KeyEvent.VK_D) ;
	img = tk.createImage(c.getResource("images/icon05.gif")) ;
	mi.addActionListener(new mkPickUp(this, img,new mkDelAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("ړ(M)", KeyEvent.VK_M) ;
	mi.addActionListener(new mkPickUp(this, null,
					  new mkMoveAction(mlay))) ;
	menu.add(mi) ;

	mi = new JMenuItem("ύX(A)", KeyEvent.VK_A) ;
	mi.addActionListener(new mkAttribAction(this)) ;
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("ݒ") ;
	mi.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
		show_config() ;
	    }}) ;
	menu.add(mi) ;
	bar.add(menu) ;

	menu = new JMenu("\(V)") ;
	menu.setMnemonic(KeyEvent.VK_V);

	JMenu submenu = new JMenu("̑傫(C)") ;
	menu.setMnemonic(KeyEvent.VK_C);

	ButtonGroup group = new ButtonGroup();

	JRadioButtonMenuItem[] rb = new JRadioButtonMenuItem[5] ;
	rb[0] = new JRadioButtonMenuItem(FONT_NAME[0]) ;
	rb[0].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(0) ;
		}}) ;
	rb[0].setMnemonic(KeyEvent.VK_0);
	group.add(rb[0]) ;
	submenu.add(rb[0]) ;

	rb[1] = new JRadioButtonMenuItem(FONT_NAME[1]) ;
	rb[1].setMnemonic(KeyEvent.VK_1);
	rb[1].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(1) ;
		}}) ;
	group.add(rb[1]) ;
	submenu.add(rb[1]) ;

	rb[2] = new JRadioButtonMenuItem(FONT_NAME[2]) ;
	rb[2].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(2) ;
		}}) ;
	rb[2].setMnemonic(KeyEvent.VK_2);
	group.add(rb[2]) ;
	submenu.add(rb[2]) ;

	rb[3] = new JRadioButtonMenuItem(FONT_NAME[3]) ;
	rb[3].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(3) ;
		}}) ;
	rb[3].setMnemonic(KeyEvent.VK_3);
	group.add(rb[3]) ;
	submenu.add(rb[3]) ;

	rb[4] = new JRadioButtonMenuItem(FONT_NAME[4]) ;
	rb[4].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(4) ;
		}}) ;
	rb[4].setMnemonic(KeyEvent.VK_4);
	group.add(rb[4]) ;
	submenu.add(rb[4]) ;

	rb[get_fno()].setSelected(true) ;

	menu.add(submenu) ;

	mi = new JMenuItem("g(E)",KeyEvent.VK_E) ;
	mi.addActionListener(new mkRectRubber(this, new mkEnlargeAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("k(S)",KeyEvent.VK_S) ;
	mi.addActionListener(new mkRectRubber(this, new mkShrinkAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("XN[(T)", KeyEvent.VK_T) ;
	img = tk.createImage(c.getResource("images/icon03.gif")) ;
	mi.addActionListener(new mkScrollAction(this,img)) ;
	menu.add(mi) ;

	mi = new JMenuItem("ĕ\", KeyEvent.VK_T) ;
	mi.addActionListener(new mkRefleshAction(this)) ;
	menu.add(mi) ;


	submenu = new JMenu("LOOKFEEL") ;
	menu.setMnemonic(KeyEvent.VK_L);

	group = new ButtonGroup();
	rb = new JRadioButtonMenuItem[4] ;

	rb[0] = new JRadioButtonMenuItem("Windows") ;
	rb[0].addActionListener(new mkLookAndFeelAction(this, 0)) ;
	rb[0].setMnemonic(KeyEvent.VK_W);
	group.add(rb[0]) ;
	submenu.add(rb[0]) ;

	rb[1] = new JRadioButtonMenuItem("Linux") ;
	rb[1].setMnemonic(KeyEvent.VK_L);
	rb[1].addActionListener(new mkLookAndFeelAction(this, 1)) ;
	group.add(rb[1]) ;
	submenu.add(rb[1]) ;

	rb[2] = new JRadioButtonMenuItem("Java") ;
	rb[2].addActionListener(new mkLookAndFeelAction(this, 2)) ;
	rb[2].setMnemonic(KeyEvent.VK_J);
	group.add(rb[2]) ;
	submenu.add(rb[2]) ;

	rb[3] = new JRadioButtonMenuItem("Unix") ;
	rb[3].addActionListener(new mkLookAndFeelAction(this, 3)) ;
	rb[3].setMnemonic(KeyEvent.VK_U);
	group.add(rb[3]) ;
	submenu.add(rb[3]) ;

	rb[get_gno()].setSelected(true) ;

	menu.add(submenu) ;

	bar.add(menu) ;


	menu = new JMenu("c[(T)") ;
	menu.setMnemonic(KeyEvent.VK_T);

	mi = new JCheckBoxMenuItem("R[h") ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    record(e) ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("vCobN") ;
	mi.addActionListener(new mkInvokToolAction("imageflip",
						   config().get(PLAYBACK_JAR)));
	menu.add(mi) ;

	mi = new JMenuItem("SVGo(G)", KeyEvent.VK_G) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    createSVG() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("HTMLo(H)", KeyEvent.VK_H) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    createHTML() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("TEXTo(T)", KeyEvent.VK_T) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    createTEXT() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("AEgC\(O)",KeyEvent.VK_O) ;
	mi.addActionListener(new mkOutlineAction(this)) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_L, ActionEvent.CTRL_MASK));
	menu.add(mi) ;

	mi = new JMenuItem("Memo(M)",KeyEvent.VK_M) ;
	mi.addActionListener(new mkInvokToolAction("memo", 
						   config().get(MEMO_JAR)));
	menu.add(mi) ;

	mi = new JMenuItem("CreativeMatrix(C)",KeyEvent.VK_C) ;
	mi.addActionListener(new mkInvokToolAction("creativematrix", 
						   config().get(CMATRIX_JAR)));
	menu.add(mi) ;


	bar.add(menu) ;

	setJMenuBar(bar) ;

	JToolBar toolBar = new JToolBar();

	JButton btn ;
	btn = new JButton( new ImageIcon(c.getResource("images/ti04.gif")));
	img = tk.createImage(c.getResource("images/icon04.gif")) ;
	btn.addActionListener(new mkFreeHandRubber(this, img,
						   new mkAddNodeAction())) ;
	btn.setToolTipText("Vl̒ǉ");
	btn.setBackground(Color.white) ;
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti06.gif")));
	btn.addActionListener(new mkPickUp(this, null, 
					   new mkTextEditAction())) ;
	btn.setToolTipText("eLXg̕ҏW");
	btn.setBackground(Color.white) ;
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti05.gif")));
	btn.addActionListener(new mkAddRelationAction(this)) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("֌Wt");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti08.gif")));
	img = tk.createImage(c.getResource("images/icon05.gif")) ;
	btn.addActionListener(new mkPickUp(this, img, new mkDelAction())) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("폜");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti07.gif")));
	btn.addActionListener(new mkPickUp(this, null, 
					   new mkMoveAction(mlay))) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("ړ");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti09.gif")));
	btn.addActionListener(new mkAttribAction(this)) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("");
	toolBar.add(btn) ;

	toolBar.addSeparator() ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti01.gif")));
	btn.addActionListener(new mkRectRubber(this, new mkEnlargeAction())) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("g");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti02.gif")));
	btn.addActionListener(new mkRectRubber(this, new mkShrinkAction())) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("k");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti03.gif")));
	img = tk.createImage(c.getResource("images/icon03.gif")) ;
	btn.addActionListener(new mkScrollAction(this, img)) ;
	btn.setBackground(Color.white) ;			
	btn.setToolTipText("XN[");
	toolBar.add(btn) ;

	_panel = new JPanel(new BorderLayout());
	_panel.setBounds(0, 0, 905, 50) ;
	_panel.add(BorderLayout.NORTH,toolBar);
	getContentPane().add(_panel) ;

	left = new mkLeftWidget() ;

	getContentPane().add(left.create(this)) ;

	

	// ---------------------------------------------


	getScreen().set_font(get_fno()).setLayer(lay) ;
    }

    public void createSVG() 
    {
	createSVG(config().get(SVG_NAME)) ;
    }


    public void createHTML() 
    {
	try {
	    left.createHTML() ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	}
    }


    public void record(ActionEvent e)
    {
	JCheckBoxMenuItem mi=	(JCheckBoxMenuItem)e.getSource() ;
	
	if(mi.getState()){
	    Preferences pref = getPreferences() ;
	    
	    String path = pref.get(DIR_NAME, DEF_DIR_NAME) ;
	    
	    int sec = pref.getInt(REC_TIME, 
				  Integer.parseInt(DEF_REC_TIME)) ;

	    getScreen().record(path+"thiningmap", sec) ;
	} else {
	    getScreen().record(null, 0) ;
	}
    }

    public void createTEXT() 
    {
	try {
	    left.createTEXT() ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	}
    }

    public void renew() 
    {
	left.clear() ;
    }

    protected mkSimpleApplet load_data(ObjectInputStream arg) 
    {
	try {
	    Object sobj = arg.readObject() ;
	    
	    mkThinkingMap save = (mkThinkingMap )sobj ;
	    
	    mkTree tre = save.getTree() ;
	    
	    mkScreen sc = getScreen() ;
	    
	    sc.set_tree(tre) ;
	    mkSubjectData subject = save.getSubject() ;
	    left.setSubject(subject) ;
	    
	    mkRegion rb = tre.get_bbox() ;
	    sc.set_auto_redraw(true) ;
	    sc.set_view(rb.get_sx(),rb.get_sy(),rb.get_ex(),rb.get_ey()) ;
	    left.initOutlineDialog(this, subject.getNode()) ;
	    sc.repaint() ;
	} catch(Exception ex){
	    mkSimpleApplet.showErrDialog(ex) ;
	}

	return this ;
    }

    protected Object save_data() 
    {
	return new mkThinkingMap(getScreen().get_tree(), left.getSubject()) ;
    }

    public void resize_event() 
    {
	Dimension d = getSize() ;
	
	this.setSize(d.width, d.height) ;
	getScreen().setSize(d.width-5, d.height-5) ;
	_panel.setSize(d.width, 50) ;
    }

    public void finish_event() 
    {
	_sal.flush() ;

	if(_tool_mode){
	    getFrame().dispose() ;
	} else {
	    System.exit(0) ;
	}
    }


    public mkSimpleApplet drop(Transferable tr, Point pt) throws Exception
    {
	DataFlavor df = new DataFlavor(mkData.class, "Data");
	mkData dat = (mkData)(tr.getTransferData(df)) ;

	mkPoint po = getScreen().dc2wc(pt.x, pt.y) ;
	
	new mkAddNodeAction().action(this, 
				     left.createShape(po),dat.get_text()) ;

	getScreen().redraw() ;

	return this ;
    }

    public mkLayer createMoveLayer()
    {
	mkLayer lay = new mkLayer() ;
	lay.setMode(mkLayer.MODE.ENABLE) ;
	lay.set_layer(mkApplet.NODE, mkLayer.TYPE.ADD) ;
	lay.set_layer(mkApplet.RELATION, mkLayer.TYPE.ADD) ;

	return lay ;
    }
}

