/*
  copyright(c) 2003-2006 Miki Akiyoshi
  
  This file is part of Miki ThinkingMap.
  
  Miki ThinkingMap is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki ThinkingMap is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki ThinkingMap; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.thinkingmap ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import java.util.* ;
import java.util.prefs.Preferences ;
import jp.dip.ikim.core.* ;

public class mkAttribAction  extends JDialog implements ActionListener , 
							ChangeListener ,
							ComponentListener,
							mkMouse 
{
    private mkApplet  _app ;
    private mkScreen  _sc ;
    private mkNodeData _target  ;
    private int _max ;
    
    private JTextField _lcname ;
    private JTextField _fcname ;
    private JTextField _tcname ;
    private JTextArea  _txarea ;
    private JScrollPane _spane ;
    private JSpinner  _sp ;

    public mkAttribAction(mkApplet arg)
    {
	super(arg.getFrame(), "ύX") ;

	_app = arg ;

	addComponentListener(this) ;

	Preferences pref = _app.getPreferences() ;

	getContentPane().setLayout(null) ;
        setSize(new Dimension(270, 300)) ;


	JLabel lb = null ;
	JPanel panel = new JPanel(null) ;
	panel.setBounds(0, 10, 270, 280) ;


	lb = new JLabel("F") ;
	lb.setBounds(5, 5, 70,30) ;
	panel.add(lb) ;

	_lcname = new JTextField() ;
	_lcname.setBounds(85,5, 125,30) ;	
	panel.add(_lcname) ;

	Class c = _app.getClass() ;
	ImageIcon ic = new ImageIcon(c.getResource("images/icon01.gif")) ;
	JButton cb = new JButton(ic) ;
	cb.setToolTipText("FI") ;
	cb.setBounds(215, 5, 20, 30) ;
	cb.addActionListener(new mkColorChooseAction(_app, _lcname)) ;
	panel.add(cb) ;

	// --------

	lb = new JLabel("hׂF") ;
	lb.setBounds(5, 40, 70,30) ;
	panel.add(lb) ;

	_fcname = new JTextField() ;
	_fcname.setBounds(85,40, 125,30) ;	
	panel.add(_fcname) ;

	cb = new JButton(ic) ;
	cb.setToolTipText("hׂFI") ;
	cb.setBounds(215, 40, 20, 30) ;
	cb.addActionListener(new mkColorChooseAction(_app, _fcname)) ;
	panel.add(cb) ;


	// ----------


	lb = new JLabel("̐F") ;
	lb.setBounds(5, 75, 70,30) ;
	panel.add(lb) ;

	_tcname = new JTextField() ;
	_tcname.setBounds(85,75, 125,30) ;	
	panel.add(_tcname) ;

	cb = new JButton(ic) ;
	cb.setToolTipText("FI") ;
	cb.setBounds(215, 75, 20, 30) ;
	cb.addActionListener(new mkColorChooseAction(_app, _tcname)) ;
	panel.add(cb) ;

	//------------

	cb = new JButton("͂") ;
	cb.setBounds(5, 105, 205,30) ;
	cb.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    reshape_target() ;
		}}) ;
	panel.add(cb) ;


	// ----------

	lb = new JLabel("") ;
	lb.setBounds(5, 145, 70,30) ;
	panel.add(lb) ;


	_sp = new JSpinner() ;
	_sp.setBounds(85,145, 125,30) ;	
	_sp.addChangeListener(this) ;

	panel.add(_sp) ;

	// ----------

	cb = new JButton("{ҏW") ;
	cb.setBounds(5, 185, 205,30) ;
	cb.addActionListener(new  ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    displayBody() ;
		}}) ;
	panel.add(cb) ;


	// ----------

	JButton btn = null ;
	btn = new JButton("ύX") ;
	btn.setBounds(15, 225, 75, 35) ;
	btn.addActionListener(new  ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    set_and_hide() ;
		}}) ;
	panel.add(btn) ;

	btn = new JButton("") ;
	btn.setBounds(100, 225, 75, 35) ;	
	btn.addActionListener(new  ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    hide() ;
		}}) ;
	panel.add(btn) ;

	getContentPane().add(panel) ;
    }

    public void actionPerformed(ActionEvent e)
    {
	try {
	    mkScreen sc = _app.getLeftWidget().getScreen() ;
	    sc.setMouse(this) ;
	    sc.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR)) ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	}
    }


    public void reshape_target()
    {
	mkScreen sc = _app.getLeftWidget().getScreen() ;
	sc.setMouse(new mkReShapeAction(_app, _target)) ;
	Toolkit tk  = Toolkit.getDefaultToolkit() ;
	Image img
	    = tk.createImage(getClass().getResource("images/icon04.gif")) ;
	sc.setCursor(img, 1, 30) ;
    }
	
    public void set_and_hide()
    {
	if(_target != null){
	    _target.set_line_color(_lcname.getBackground()) ;
	    _target.set_fill_color(_fcname.getBackground()) ;
	    _target.set_text_color(_tcname.getBackground()) ;
	    _target.setBody(_txarea != null ? _txarea.getText() : "") ;
	    _app.getLeftWidget().setUpdateFlag(true) ;
	    super.hide() ;
	    _app.getLeftWidget().getScreen().redraw() ;
	    mkRelation pr =  _target.getParent() ;
	    pr.getParent().replaceChild(pr, 
					((Integer )_sp.getValue()).intValue()) ;
	}
    }

    public void mouseClicked(MouseEvent e, mkScreen sc) 
    {
		
    }
    
    public void mousePressed(MouseEvent e, mkScreen sc) 
    {
  	int x = e.getX();
  	int y = e.getY();

	mkPoint sp = sc.dc2wc(x, y) ;

	mkOneSearch os = new mkOneSearch(sp) ;

	sc.get_tree().search(os) ;

	_target = (mkNodeData )os.get_one() ;

	show() ;
    }
    
    public void mouseReleased(MouseEvent e, mkScreen sc) 
    {

    }
    
    public void mouseEntered(MouseEvent e, mkScreen sc) 
    {

    }
    
    public void mouseExited(MouseEvent e, mkScreen sc) 
    {

    }

    public void mouseDragged(MouseEvent e, mkScreen sc) 
    {

	

    }

    public void mouseMoved(MouseEvent e, mkScreen sc) 
    {
	
    }

    public void mouseDoubleClicked(MouseEvent e, mkScreen sc) 
    {

    }

    public void show()
    {
	Preferences pref = _app.getPreferences() ;


	Color  col = _target.get_line_color() ;
	_lcname.setBackground(col) ;
	_lcname.setText(mkConfig.Color2String(col)) ;

	col = _target.get_fill_color() ;
	_fcname.setBackground(col) ;
	_fcname.setText(mkConfig.Color2String(col)) ;

	col = _target.get_text_color() ;
	_tcname.setBackground(col) ;
	_tcname.setText(mkConfig.Color2String(col)) ;

	// {ҏWʂO\ꍇɖ߂
	if(_spane != null){
	    getContentPane().remove(_spane) ;
	    setSize(new Dimension(270, 300)) ;
	}

	mkRelation pr =  _target.getParent() ;
	if(pr != null && pr.getParent() != null){
	    int val  = pr.getParent().getChildIndex(pr) ;
	    _sp.setEnabled(true) ;
	    _sp.setValue(new Integer(val)) ;
	    _max = pr.getParent().getChildrenNum() - 1 ;
	} else {
	    _sp.setEnabled(false) ;
	}
	super.show() ;
    }
    
    public void stateChanged(ChangeEvent e)
    {
	JSpinner jsp = (JSpinner )e.getSource() ;

	Integer iobj = (Integer )jsp.getPreviousValue() ;
	if(iobj.intValue() < 0){
	    jsp.setValue(new Integer(0)) ;
	} 

	iobj = (Integer )jsp.getNextValue() ;
	if(iobj.intValue() > _max){
	    jsp.setValue(new Integer(_max)) ;	    
	}
    }

    public void displayBody()
    {
	_txarea = new JTextArea() ;
	_txarea.setLineWrap(true) ; 
	_txarea.setWrapStyleWord(true) ;
	_spane = new JScrollPane(_txarea) ;

	_spane.setBounds(5,300, 590,270) ;	
        _spane.setVerticalScrollBarPolicy(
			  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS) ;
        _spane.setPreferredSize(new Dimension(590, 270));
        _spane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("{"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                _spane.getBorder()));	

	_txarea.setText(_target.getBody()) ;

	getContentPane().add(_spane) ;	
	requestFocus() ;
	setSize(610, 600) ;

	repaint() ;
    }

    public void componentResized(ComponentEvent e){}

    public void componentMoved(ComponentEvent e){}

    public void componentShown(ComponentEvent e){}

    public void componentHidden(ComponentEvent e){}

    public void change(mkMouse n, mkScreen sc) 
    {

    }

}

