/*
  copyright(c) 2003-2006 Miki Akiyoshi
  
  This file is part of Miki ThinkingMap.
  
  Miki ThinkingMap is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki ThinkingMap is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki ThinkingMap; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.thinkingmap ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.tree.* ;
import java.io.* ;
import java.util.* ;
import java.text.* ;
import java.awt.dnd.* ;
import org.w3c.dom.* ;
import javax.xml.parsers.* ;
import javax.xml.transform.* ;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
import java.util.prefs.Preferences ;
import jp.dip.ikim.core.* ;

import static jp.dip.ikim.core.mkConfig.DIR_NAME ;
import static jp.dip.ikim.core.mkConfig.DEF_DIR_NAME ;

import static jp.dip.ikim.thinkingmap.mkApplet.SVG_NAME ;
import static jp.dip.ikim.thinkingmap.mkApplet.DEF_SVG_NAME ;


public class mkLeftWidget implements Serializable
{
    private boolean update_flag = false ;

    private mkOutlineDialog _odialog ;

    public void setUpdateFlag(boolean arg)
    {
	update_flag = arg ;
    }

    public boolean updatep()
    {
	return update_flag ;
    }


    public mkLeftWidget()
    {
	super() ;

    }


    public mkOutlineDialog getOutlineDialog()
    {
	return _odialog ;
    }

    transient private mkApplet _app ;
    private mkScreen  _sc ;

    public mkScreen getScreen()
    {
	return _sc ;
    }

    public JComponent create(mkApplet arg)
    {
	_app = arg ;

	_sc = new mkScreen() ;
	_sc.setBackground(Color.red) ;
	_sc.setBounds(0, 60, 905, 590) ;

	arg.setScreen(_sc) ;

	return _sc ;
    }

    
    public void addNode()
    {
	
    }

    private mkSubjectData _subject ;

    public mkSubjectData getSubject()
    {
	return _subject ;
    }

    public void setSubject(mkSubjectData arg)
    {
	_subject = arg ;
    }


    public mkPoint[] createShape(mkPoint ap)
    {
	mkPoint[] po = new mkPoint[8] ;

	po[0] = new mkPoint(-50.0, -45.0) ;
	po[1] = new mkPoint(-45.0, -50.0) ;
	po[2] = new mkPoint(45.0, -50.0) ;
	po[3] = new mkPoint(50.0, -45.0) ;
	po[4] = new mkPoint(50.0, 45.0) ;
	po[5] = new mkPoint(45.0, 50.0) ;
	po[6] = new mkPoint(-45.0, 50.0) ;
	po[7] = new mkPoint(-50.0, 45.0) ;

	for(int i = 0; i < po.length; i++){
	    po[i].translate(ap.get_x(), ap.get_y()) ;
	}

	return po ;
    }


    public void clear()
    {
	setUpdateFlag(false) ;
	_sc.set_tree(new mkTree(0)) ;

	mkPoint[] po = new mkPoint[8] ;

	po[0] = new mkPoint(-50.0, -45.0) ;
	po[1] = new mkPoint(-45.0, -50.0) ;
	po[2] = new mkPoint(45.0, -50.0) ;
	po[3] = new mkPoint(50.0, -45.0) ;
	po[4] = new mkPoint(50.0, 45.0) ;
	po[5] = new mkPoint(45.0, 50.0) ;
	po[6] = new mkPoint(-45.0, 50.0) ;
	po[7] = new mkPoint(-50.0, 45.0) ;

	_subject = new mkSubjectData("",po) ;
	_subject.set_line_color(_app.config().getLineColor()) ;
	_subject.set_fill_color(_app.config().getFillColor()) ;
	_subject.set_text_color(_app.config().getTextColor()) ;
	_subject.set_layer(mkApplet.SUBJECT) ;
	initOutlineDialog(_app, _subject.getNode()) ;
	_sc.get_tree().insertData(_subject) ;
	_sc.set_view(-500, -500, 500, 500) ;
	_sc.set_auto_redraw(true) ;
	_sc.redraw() ;
    }	

    public void initOutlineDialog(mkApplet app,
				  DefaultMutableTreeNode top)
    {
	if(_odialog == null){
	    Frame fm = new Frame() ;
	    fm.setLocationByPlatform(true) ;
	    _odialog =  
		new mkOutlineDialog(app, top, fm, "AEgC") ;
	} else {
	    _odialog.getModel().setRoot(top) ;
	}
    }

    static public final String h_pid = "-//W3C//DTD XHTML 1.0 Strict//EN" ;
    static public final String h_sid = 
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" ;


    public void createHTML() throws Exception
    {
	DocumentBuilderFactory dbf = 
	    DocumentBuilderFactory.newInstance() ;
	dbf.setValidating(true) ;
	DocumentBuilder db =  dbf.newDocumentBuilder() ;
	Document doc = db.newDocument() ;

	_subject.createHTML(doc, doc.createElement("html"), 0) ;

	TransformerFactory t = TransformerFactory.newInstance() ;
	Transformer tf = t.newTransformer() ;
	tf.setOutputProperty(OutputKeys.ENCODING,"Shift_JIS");
	tf.setOutputProperty(OutputKeys.DOCTYPE_PUBLIC, h_pid) ;
	tf.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM, h_sid) ;
	tf.setOutputProperty(OutputKeys.METHOD, "xml") ;

	Preferences pref = _app.getPreferences() ;
	/*
	  String path = 
	  pref.get(DIR_NAME, DEF_DIR_NAME) + 
	  pref.get(HTML_NAME, DEF_HTML_NAME) ;
	*/
	String path = null ;

	tf.transform(new DOMSource(doc), new StreamResult(path)) ;
    }


    public void createTEXT() throws Exception
    {
	DocumentBuilderFactory dbf = 
	    DocumentBuilderFactory.newInstance() ;
	dbf.setValidating(true) ;
	DocumentBuilder db =  dbf.newDocumentBuilder() ;
	Document doc = db.newDocument() ;

	_subject.createHTML(doc, doc.createElement("html"), 0) ;

	TransformerFactory t = TransformerFactory.newInstance() ;
	Transformer tf = t.newTransformer() ;
	tf.setOutputProperty(OutputKeys.ENCODING,"Shift_JIS");
	tf.setOutputProperty(OutputKeys.DOCTYPE_PUBLIC, h_pid) ;
	tf.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM, h_sid) ;
	tf.setOutputProperty(OutputKeys.METHOD, "text") ;	
	tf.setOutputProperty(OutputKeys.INDENT, "yes") ;


	Preferences pref = _app.getPreferences() ;
	/*
	String path = 
	    pref.get(mkApplet.DIR_NAME, mkApplet.DEF_DIR_NAME) + 
	    pref.get(mkApplet.TEXT_NAME, mkApplet.DEF_TEXT_NAME) ;
	*/	    
	String path = null ;
	tf.transform(new DOMSource(doc), new StreamResult(path)) ;
    }


}

