/*
  copyright(c) 2003-2006 Miki Akiyoshi
  
  This file is part of Miki ThinkingMap.
  
  Miki ThinkingMap is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki ThinkingMap is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki ThinkingMap; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.thinkingmap ;

import java.util.* ;
import java.awt.* ;
import javax.swing.* ;
import javax.swing.tree.* ;
import org.w3c.dom.* ;
import javax.xml.parsers.* ;
import javax.xml.transform.* ;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
import jp.dip.ikim.core.* ;

public class mkNodeData extends mkSimpleData
{
    static final String DEF_TEXT = "Vl" ;

    static final long serialVersionUID = -7974060866387270638L;

    private mkRelation  _parent ;

    private Vector      _children = new Vector() ;

    private boolean dirty = true ;

    private String   _body ;

    private DefaultMutableTreeNode _node ;

    public  DefaultMutableTreeNode getNode() 
    {
	return _node ;
    }

    public String setBody(String arg)
    {
	_body = arg ;

	return _body ;
    }

    public String getBody()
    {
	return _body ;
    }

    public mkNodeData setParent(mkRelation rel)
    {
	// Ɋ֌WtĂꍇ͎q폜ꂽ
	// ݂Ȃč폜s
	if(_parent != null){
	    _parent.delChild() ;
	}

	_parent = rel ;

	return this ;
    }

    public void replaceChild(mkRelation rel, int idx)
    {
	_children.removeElement(rel) ;

	_node.remove(rel.getChild().getNode()) ;

	_children.insertElementAt(rel, idx) ;

	_node.insert(rel.getChild().getNode(), idx) ;

	return ;
    }

    public mkNodeData addChild(mkRelation rel)
    {
	_children.addElement(rel) ;

	_node.add(rel.getChild().getNode()) ;

	return this ;
    }


    public void translate(double tx, double ty, mkTree tr)
    {
	try {
	    tr.removeData(this) ;

	    translate(tx, ty) ;

	    if(_parent != null){
		_parent.moveChild(this, tx, ty) ;
		tr.removeData(_parent) ;
		tr.insertData(_parent) ;
	    }

	    Enumeration en = getChildren() ;

	    if(en != null){
		while(en.hasMoreElements()){
		    mkRelation rel = (mkRelation )en.nextElement() ;
		    rel.moveParent(this, tx, ty) ;
		    tr.removeData(rel) ;
		    tr.insertData(rel) ;
		}
	    }
	    tr.insertData(this) ;
	} catch(Exception ex){
	    mkSimpleApplet.showErrDialog(ex) ;
	}
    }	
	
    public mkData del()
    {
	super.del() ;

	if(_parent != null){
	    _parent.delChild() ;
	}
	_parent = null ;

	Enumeration en = getChildren() ;

	if(en != null){
	    while(en.hasMoreElements()){
		mkRelation rel = (mkRelation )en.nextElement() ;
		rel.delParent() ;
	    }
	}

	return this ;
    }

    public mkNodeData delParent()
    {
	_parent = null ;

	return this ;
    }

    public mkNodeData delChild(mkRelation rel)
    {
	_children.removeElement(rel) ;

	_node.remove(rel.getChild().getNode()) ;

	return this ;
    }

    public mkRelation getParent()
    {
	return _parent ;
    }

    public int getChildrenNum()
    {
	return _children.size() ;
    }

    public int getChildIndex(mkRelation arg)
    {
	return _children.indexOf(arg) ;
    }

    public Enumeration getChildren()
    {
	return (_children == null ? null : _children.elements()) ;
    }

    public void set_text(String arg)
    {
	super.set_text(arg) ;

	if(_node == null){
	    createNode(this) ;
	} else {
	    _node.setUserObject(this) ;
	}
    }

    public mkNodeData(mkPoint[] args)
    {
	this(DEF_TEXT, args) ;
    }

    public mkNodeData(String arg, mkPoint[] args)
    {
	super(new mkPolygonShape(args)) ;

	setTextShape(new mkTextBox(arg)) ;

	_node = createNode(this) ;

	
    }

    public mkNodeData(String arg)
    {
	super() ;

	setTextShape(new mkTextBox(arg)) ;

	_node = createNode(this) ;
    }


    public mkNodeData()
    {
	super() ;
	_node = createNode(this) ;
    }

    public Object clone() 
    {
	try {
	    mkNodeData other = (mkNodeData )super.clone();
	    return other;
	} catch (Exception e) {
	    // this shouldn't happen, since we are Cloneable
	    throw new InternalError();
	}
    }

    public String toString()
    {
	return get_text() ;
    }

    static public DefaultMutableTreeNode createNode(mkNodeData arg)
    {
	DefaultMutableTreeNode node = new DefaultMutableTreeNode() ;

	node.setUserObject(arg) ;

	return node ;
    }

    public void createHTML(Document doc, Element top, int level) 
    {
	Element elm = doc.createElement("h"+level) ;
	Text tx = doc.createTextNode(get_text()) ;
	elm.appendChild(tx) ;
	
	top.appendChild(elm) ;

	if(_body != null){
	    elm = doc.createElement("p") ;
	    tx = doc.createTextNode(_body) ;
	    elm.appendChild(tx) ;
	
	    top.appendChild(elm) ;
	}

	++level ;
	Enumeration en = _children.elements() ;
	while(en.hasMoreElements()){
	    mkRelation nod = (mkRelation )en.nextElement() ;
	    nod.getChild().createHTML(doc, top, level) ;
	}

    }

    protected void indraw(mkScreen screen)
    {
	if(_shape != null){
	    _shape.draw(screen, get_line_color(), 
			get_fill_color(), get_text_color()) ;
	}

	if(_tx_shape != null){
	    _tx_shape.draw(screen, _bbox,
			   null, null, get_text_color(),
			   _align, _valign) ;
	}
    }


}








