/*
  copyright(c) 2003-2006 Miki Akiyoshi
  
  This file is part of Miki ThinkingMap.
  
  Miki ThinkingMap is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki ThinkingMap is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki ThinkingMap; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.thinkingmap ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import javax.swing.tree.* ;
import java.io.* ;
import java.util.* ;
import java.awt.dnd.* ;
import java.util.prefs.Preferences ;
import jp.dip.ikim.core.* ;

public class mkOutlineDialog extends JDialog
    implements Serializable ,
	       ActionListener ,
	       TreeSelectionListener ,
	       TreeModelListener
{
    mkApplet _app ;

    JTree     _tree ;
    DefaultTreeModel _model ;
    private  JTextArea _txarea ;

    public DefaultTreeModel getModel()
    {
	return _model ;
    }

    public mkOutlineDialog(mkApplet app, DefaultMutableTreeNode top,
			   Frame frame, String title)
    {
	super(frame, title) ;

	_app = app ;

	mkLeftWidget lw = _app.getLeftWidget() ;


	getContentPane().setLayout(null) ;
        setSize(new Dimension(710, 705)) ;

	mkNodeData node = lw.getSubject() ;

	// createTree(top, node) ;

	_model = new DefaultTreeModel(top) ;
	_model.addTreeModelListener(this)  ;

	_tree = new JTree(_model) ;
	_tree.setEditable(true) ;
	_tree.setDragEnabled(true) ;

	_tree.addTreeSelectionListener(this) ;

	Class c = getClass() ;
	ImageIcon ic = new ImageIcon(c.getResource("images/icon10.gif")) ;

	if (ic != null) {
	    DefaultTreeCellRenderer renderer = 
		new DefaultTreeCellRenderer();
	    renderer.setLeafIcon(ic);
	    renderer.setClosedIcon(ic) ;
	    renderer.setOpenIcon(ic) ;
	    _tree.setCellRenderer(renderer);
	}


	JScrollPane spane = new JScrollPane(_tree) ;

	spane.setBounds(5,5, 580,400) ;	
        spane.setVerticalScrollBarPolicy(
			  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS) ;
        spane.setPreferredSize(new Dimension(400, 270));
        spane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("e"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                spane.getBorder()));	

	getContentPane().add(spane) ;

	JButton	btn = new JButton("ǉ") ;
	btn.setBounds(620, 5, 75, 35) ;

	/*
	btn.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    add_node() ;
		}});
	*/

	getContentPane().add(btn) ;

	btn = new JButton("폜") ;
	btn.setBounds(620, 55, 75, 35) ;
	btn.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    del_node() ;
		}});
	getContentPane().add(btn) ;

	btn = new JButton("OK") ;
	btn.setBounds(620, 105, 75, 35) ;
	btn.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
		    hide() ;
		}});
	getContentPane().add(btn) ;

	_txarea = new JTextArea() ;
	_txarea.setLineWrap(true) ; 
	_txarea.setWrapStyleWord(true) ;

	spane = new JScrollPane(_txarea) ;

	spane.setBounds(5,410, 590,270) ;	
        spane.setVerticalScrollBarPolicy(
			  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS) ;
        spane.setPreferredSize(new Dimension(590, 270));
        spane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("{"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                spane.getBorder()));	

	getContentPane().add(spane) ;
    }

	
    private void createTree(DefaultMutableTreeNode jnode, 
			    mkNodeData node)
    {
	Enumeration en = node.getChildren() ;

	if(en == null){
	    return ;
	}
	while(en.hasMoreElements()){
	    mkRelation rel = (mkRelation )en.nextElement() ;
	    DefaultMutableTreeNode jnode2 = 
		new DefaultMutableTreeNode(rel.getChild()) ;
	    jnode.add(jnode2) ;
	    createTree(jnode2, rel.getChild()) ;
	}
    }	

    public void hide()
    {
	if(_target != null){
	    _target.setBody(_txarea.getText()) ;
	}

	super.hide() ;
    }

    public void actionPerformed(ActionEvent e)
    {
	hide() ;
    }

    public void show()
    {
	_model.reload() ;

	_txarea.setText("") ;

	super.show() ;
    }


    public void add_node()
    {
	DefaultMutableTreeNode last = getLast() ;

	if(last == null) return ;

	mkNodeData parent = (mkNodeData )last.getUserObject() ;
	mkPoint cp = parent.get_center() ;

	double x = cp.get_x() *1.2 ;
	double y = cp.get_y() *1.2 ;

	mkPoint[] po = new mkPoint[8] ;

	po[0] = new mkPoint(-50.0+x, -45.0+y) ;
	po[1] = new mkPoint(-45.0+x, -50.0+y) ;
	po[2] = new mkPoint(45.0+x, -50.0+y) ;
	po[3] = new mkPoint(50.0+x, -45.0+y) ;
	po[4] = new mkPoint(50.0+x, 45.0+y) ;
	po[5] = new mkPoint(45.0+x, 50.0+y) ;
	po[6] = new mkPoint(-45.0+x, 50.0+y) ;
	po[7] = new mkPoint(-50.0+x, 45.0+y) ;

	mkNodeData ndata = new mkNodeData(po) ;
	mkScreen sc = _app.getLeftWidget().getScreen() ;
	sc.get_tree().insertData(ndata) ;

	po = new mkPoint[3] ;	
	po[0] = (mkPoint )cp.clone() ;
	po[1] = new mkPoint(x, cp.get_y()) ;
	po[2] = (mkPoint )cp.clone() ;
	mkRelation rel = new mkRelation(po, parent, ndata) ;
	sc.get_tree().insertData(rel) ;

	_model.reload(parent.getNode());
	sc.redraw() ;
    }



    public void del_node()
    {
	DefaultMutableTreeNode last = getLast() ;

	if(last == null) return ;

	// 폜
	mkNodeData ndata = (mkNodeData )last.getUserObject() ;
	ndata.del() ;

	_model.reload();

	_app.getLeftWidget().getScreen().redraw() ;
    }

    public DefaultMutableTreeNode getLast()
    {
	// ݑIĂm[h܂łTreePath擾 
	TreePath treePath = _tree.getSelectionPath() ;
	if (treePath == null){
	    return null ;
	}
	
	// Path̍Ō̍ڂ擾 
	DefaultMutableTreeNode lastPath = 
	    (DefaultMutableTreeNode)treePath.getLastPathComponent();

	return lastPath ;
    }

    private mkNodeData _target ;

    public void valueChanged(TreeSelectionEvent e)
    {
	TreePath treePath = e.getPath() ;

	// Path̍Ō̍ڂ擾 
	DefaultMutableTreeNode last = 
	    (DefaultMutableTreeNode)treePath.getLastPathComponent();

	_target = (mkNodeData )last.getUserObject() ;

	_txarea.setText(_target.getBody()) ;
    }

    public void treeNodesChanged(TreeModelEvent e)
    {
	TreePath treePath = e.getTreePath() ;

	// Path̍Ō̍ڂ擾 
	DefaultMutableTreeNode last = 
	    (DefaultMutableTreeNode)treePath.getLastPathComponent();

	int index = e.getChildIndices()[0];
	DefaultMutableTreeNode node =
	    (DefaultMutableTreeNode)(last.getChildAt(index));
	
	_target.set_text(node.getUserObject().toString()) ;
	
	_app.getLeftWidget().getScreen().redraw() ;
    }

    public void treeNodesInserted(TreeModelEvent e)
    {

    }

    public void treeNodesRemoved(TreeModelEvent e)
    {

    }

    public void treeStructureChanged(TreeModelEvent e)
    {

    }

}


