/*
  copyright(c) 2003-2006 Miki Akiyoshi
  
  This file is part of Miki ThinkingMap.
  
  Miki ThinkingMap is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki ThinkingMap is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki ThinkingMap; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.thinkingmap ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.util.* ;
import jp.dip.ikim.core.* ;

public class mkReShapeAction implements mkMouse
{
    mkApplet  _app ;
    mkNodeData _target ;

    public mkReShapeAction(mkApplet arg, mkNodeData target)
    {
	_app = arg ;
	_target = target ;
    }

    private mkPoint _sp ;
    private int    _oldx, _oldy ;
    private Vector  _list = new Vector() ;

    public void mouseClicked(MouseEvent e, mkScreen sc) 
    {
		
    }
    
    public void mousePressed(MouseEvent e, mkScreen sc) 
    {
  	_oldx = e.getX();
  	_oldy = e.getY();

	_sp = sc.dc2wc(_oldx, _oldy) ;
	_list.addElement(_sp) ;
    }
    
    public void mouseReleased(MouseEvent e, mkScreen sc) 
    {
  	int x = e.getX();
  	int y = e.getY();


	mkPoint pp = sc.dc2wc(x, y) ;
	if(! pp.equals(_sp)){
	    _list.addElement(pp) ;
	}

	Object[] objlist = _list.toArray() ;

	mkPoint[] points = new mkPoint[objlist.length] ;
	for(int i = 0; i < points.length; i++){
	    points[i] = (mkPoint )objlist[i] ;
	}

	 _target.setShape(new mkPolygonShape(points)) ;
	 
	 _app.getLeftWidget().setUpdateFlag(true) ;
	 
	 sc.set_offscreen_mode(true) ;
	 sc.redraw() ;
	 
	 _sp = null ;
	 _list.removeAllElements() ;
    }
    
    public void mouseEntered(MouseEvent e, mkScreen sc) 
    {

    }
    
    public void mouseExited(MouseEvent e, mkScreen sc) 
    {

    }

    public void mouseDragged(MouseEvent e, mkScreen sc) 
    {
  	int x = e.getX();
  	int y = e.getY();

	if(_oldx == x && _oldy == y){
	    return ;
	}

	sc.set_offscreen_mode(false) ;
	sc.set_line_color(Color.black) ;
	sc.dc_line(_oldx, _oldy, x, y) ;
	
	_oldx = x ;
	_oldy = y ;

	mkPoint pp = sc.dc2wc(x, y) ;
	if(pp.equals(_sp)){
	    return ;
	}
	_list.addElement(pp) ;
	_sp = pp ;

    }

    public void mouseMoved(MouseEvent e, mkScreen sc) 
    {
	
    }

    public void mouseDoubleClicked(MouseEvent e, mkScreen sc) 
    {

    }

    public void change(mkMouse n, mkScreen sc) 
    {

    }

}

