/*
  copyright(c) 2003-2006 Miki Akiyoshi
  
  This file is part of Miki ThinkingMap.
  
  Miki ThinkingMap is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki ThinkingMap is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki ThinkingMap; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.thinkingmap ;

import java.util.List ;
import java.util.ArrayList ;
import java.awt.Color ;
import org.w3c.dom.* ;
import javax.xml.parsers.* ;
import javax.xml.transform.* ;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
import jp.dip.ikim.core.* ;
import jp.dip.ikim.core.mkTextShape.ALIGN ;
import jp.dip.ikim.core.mkTextShape.VALIGN ;

public class mkRelation extends mkSimpleData
{
    static final long serialVersionUID = -8031858851150431885L;

    private mkNodeData _parent ;

    private mkNodeData _child ;

    private int _tbase ;
    private mkRegion _tbox ;

    public mkRelation()
    {
	super() ;
    }
    
    public mkNodeData getParent()
    {
	return _parent ;
    }

    
    public mkNodeData getChild()
    {
	return _child ;
    }


    public void connect(mkNodeData parent, mkNodeData child)
    {
	// eDefaultMutableTreeNodeadd邽
	// Kq

	_child = child ;
	if(eq(parent, child, _child.getParent())){
	    set_text(_child.getParent().get_text()) ;
	}
	_child.setParent(this) ;

	_parent = parent ;
	_parent.addChild(this) ;
	
    }

    public mkRelation(mkPoint[] args, mkNodeData parent, mkNodeData child)
    {
	super(new mkPolylineShape(args)) ;

	setTextShape(new mkTextBox("@t@f̊֌W")) ;

	connect(parent, child) ;

	_tbase = args.length/2 ;

	_tbox = get_tbox(_shape.get_points(), _shape.get_points()[_tbase]) ;
    }

    public void moveChild(mkNodeData newnode, double tx, double ty) 
    {
	mkPoint[] po = _shape.get_points() ;
	mkPoint lastp = po[ po.length -1] ;

	double rx = po[0].get_x() ;
	double ry = po[0].get_y() ;
	
	double sx = 
	    (lastp.get_x() - rx + tx) / (lastp.get_x() - rx) ;
	double sy =
	    (lastp.get_y() - ry + ty) / (lastp.get_y() - ry) ; 
	
	for(int i = 0; i < po.length; i++){
	    po[i].set_x(sx * (po[i].get_x() -rx) + rx) ;
	    po[i].set_y(sy * (po[i].get_y() -ry) + ry) ;
	}
	
	// ւ
	_child = newnode ;

	super.set(new mkRegion(po)) ;
    }


    public void moveParent(mkNodeData newnode, double tx, double ty) 
    {
	mkPoint[] po = _shape.get_points() ;

	mkPoint firstp = po[0] ;

	double rx = po[po.length -1 ].get_x() ;
	double ry = po[po.length -1 ].get_y() ;
	
	double sx = 
	    (firstp.get_x() - rx + tx) / (firstp.get_x() - rx) ;
	double sy =
	    (firstp.get_y() - ry + ty) / (firstp.get_y() - ry) ; 
	
	for(int i = 0; i < po.length; i++){
	    po[i].set_x(sx * (po[i].get_x() -rx) + rx) ;
	    po[i].set_y(sy * (po[i].get_y() -ry) + ry) ;
	}

	// ւ
	_parent = newnode ;

	super.set(new mkRegion(po)) ;
    }


    public void delChild() 
    {
	_parent.delChild(this) ;

	del() ;
    }

    public void delParent() 
    {
	_child.delParent() ;

	del() ;
    }

    public mkRegion get_text_bbox()
    {
	return _tbox ;
    }


    public String get_format_text()
    {
	String ps = _parent.get_text() ;
	String cs = _child.get_text() ;

	String ts = get_text().replace("@f", ps) ;

	return ts.replace("@t", cs) ;
    }

    protected void indraw(mkScreen screen) 
    {
	// obNAbv
	String bs = _tx_shape.get_text() ;

	String[] sg =  new String[1] ;
	sg[0] = get_format_text() ;

	// tŕ`
	((mkPolylineShape )_shape).disp_arrow() ;
	_tx_shape.set_text(sg[0]) ;

	_shape.draw(screen, get_line_color(), 
		    get_fill_color(), get_text_color()) ;

	_tx_shape.draw(screen,  
		       get_tbox(_shape.get_points(), _tbox.get_center()),
		       null, null, get_text_color(),
		       ALIGN.CENTER, VALIGN.MIDDLE) ;

	_tx_shape.set_text(bs) ;	
    }

    protected mkRegion get_tbox(mkPoint[] ap, mkPoint cp)
    {
	String sg = get_format_text() ;

	double width = Math.sqrt(sg.length()) * 20 ;
	double height = width * 1.5 ;

	_tbase = mkPoint.get_nearest_p(ap, cp.get_x(), cp.get_y()) ;

	mkPoint po =  ap[_tbase] ;

	double sx = po.get_x() - width/2 ;
	double ex = po.get_x() + width/2 ;
	double sy = po.get_y() ;
	double ey = sy ;

	return new mkRegion(sx, sy, ex, ey) ;
    }

    public boolean eq(mkNodeData parent, mkNodeData child, mkRelation arg)
    {

	if(arg == null) return false ;

	return (parent == arg.getParent() && child == arg.getChild()) ;
    }

    public void translate(double tx, double ty)
    {
	mkPoint tmp = _tbox.get_center() ;

	if(_bbox.inner((tmp.get_x()+tx), (tmp.get_y()+ty))){
	    _tbox.translate(tx, ty) ;
	}
    }

}
